//: C01:Terminator.cpp
// Z knihy "Myslíme v jazyce C++, část 2" od Bruce Eckela a Chucka Allisona.
// (c) 1995-2004 MindView, Inc. Všechna práva vyhrazena.
// Přečtěte si podmínky používání zdrojových kódů umístěné v souboru 
// 'Licence.txt' dodávaném spolu s balíčkem kódu dostupným na www.MindView.net.
// Použití funkce set_terminate(). Také ukazuje nezachycené výjimky.
#include <exception>
#include <iostream>
using namespace std;

void terminator() {
  cout << "Já se vrátím!" << endl;
  exit(0);
}

void (*old_terminate)() = set_terminate(terminator);

class Paskvil {
public:
  class Ovoce {};
  void f() {
    cout << "Paskvil::f()" << endl;
    throw Ovoce();
  }
  ~Paskvil() { throw 'c'; }
};

int main() {
  try {
    Paskvil p;
    p.f();
  } catch(...) {
    cout << "uvnitř catch(...)" << endl;
  }
} ///:~
